## ros-one-plotjuggler 3.9.2-21noble.20251022.2358

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2)

PROJECT(plotjuggler LANGUAGES C CXX VERSION 3.9.3)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH}  "${CMAKE_CURRENT_LIST_DIR}/cmake")

add_definitions(
    -DPJ_MAJOR_VERSION=${PROJECT_VERSION_MAJOR}
    -DPJ_MINOR_VERSION=${PROJECT_VERSION_MINOR}
    -DPJ_PATCH_VERSION=${PROJECT_VERSION_PATCH} )

# You can add some command line arguments at compilation time
# Use _0x3b_ instead of semicolon

#set(PJ_DEFAULT_ARGS "-n --enabled_plugins=libDataLoadCSV_0x3b_libDataStreamSample")
#add_definitions( -DPJ_DEFAULT_ARGS="${PJ_DEFAULT_ARGS}")

option(ENABLE_ASAN "Enable Address Sanitizer" OFF)
option(BASE_AS_SHARED "Build the base library as a shared libary" OFF)
option(BUILDING_WITH_CONAN "Using Conan for depenencies" OFF)

IF (NOT WIN32 AND ENABLE_ASAN)
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-omit-frame-pointer -fsanitize=address")
  set (CMAKE_LINKER_FLAGS "${CMAKE_LINKER_FLAGS} -fno-omit-frame-pointer -fsanitize=address")
endif()

include_directories( plotjuggler_base/include )
include_directories( plotjuggler_base/src )

add_definitions( -DFMT_HEADER_ONLY )


if(VCPKG_TOOLCHAIN)
    set(BUILDING_WITH_VCPKG ON)
    message(STATUS "BUILDING_WITH_VCPKG")
endif()

find_package(ament_cmake QUIET)
find_package(catkin QUIET)

# http://answers.ros.org/question/230877/optionally-build-a-package-with-catkin/
if(catkin_FOUND)
    set(COMPILING_WITH_CATKIN 1)

    message(STATUS "--------------------------------------------------")
    message(STATUS "PlotJuggler is being built using CATKIN.")
    message(STATUS "--------------------------------------------------")

    find_package(catkin REQUIRED COMPONENTS roslib roscpp)

    catkin_package(
        INCLUDE_DIRS  plotjuggler_base/include
        LIBRARIES  plotjuggler_base
        CATKIN_DEPENDS roslib roscpp
    )

message(STATUS ${catkin_INCLUDE_DIRS})

    include_directories(${catkin_INCLUDE_DIRS})
    add_definitions(-DCOMPILED_WITH_CATKIN)

elseif(ament_cmake_FOUND)
    set(COMPILING_WITH_AMENT 1)

    find_package(ament_cmake REQUIRED)
    find_package(ament_index_cpp REQUIRED)
    find_package(rclcpp REQUIRED)
    include_directories(${ament_index_cpp_INCLUDE_DIRS})

    message(STATUS "--------------------------------------------------")
    message(STATUS "PlotJuggler is being built using AMENT.")
    message(STATUS "--------------------------------------------------")

    add_definitions(-DCOMPILED_WITH_AMENT)

else()
    message(STATUS "--------------------------------------------------")
    message(STATUS "PlotJuggler is being built WITHOUT any ROS support")
    message(STATUS "--------------------------------------------------")
endif()

cmake_policy (SET CMP0020 NEW)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
SET(CMAKE_AUTOUIC ON)


if (NOT WIN32)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-omit-frame-pointer")
endif()

if(APPLE AND EXISTS /usr/local/opt/qt5)
    # Homebrew installs Qt5 (up to at least 5.9.1) in
    # /usr/local/qt5, ensure it can be found by CMake since
    # it is not in the default /usr/local prefix.
    # source: https://github.com/Homebrew/homebrew-core/issues/8392#issuecomment-325226494
    list(APPEND CMAKE_PREFIX_PATH "/usr/local/opt/qt5")
    set(CMAKE_MACOSX_RPATH 1)
elseif(APPLE AND EXISTS /opt/homebrew/opt/qt@5)
    list(APPEND CMAKE_PREFIX_PATH "/opt/homebrew/opt/qt@5")
    set(CMAKE_MACOSX_RPATH 1)
endif()

find_package(Qt5 REQUIRED COMPONENTS
    Core
    Widgets
    PrintSupport
    Concurrent
    Xml
    Svg
    OpenGL
    WebSockets
    Network)

set( QT_LINK_LIBRARIES
    Qt5::Core
    Qt5::Widgets
    Qt5::PrintSupport
    Qt5::Xml
    Qt5::Concurrent
    Qt5::Svg
    Qt5::OpenGL
    Qt5::WebSockets
    )


if (NOT CMAKE_BUILD_TYPE)
    message(STATUS "No build type selected, default to RelWithDebInfo")
    set(CMAKE_BUILD_TYPE "RelWithDebInfo")
endif()

IF (NOT WIN32)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -fPIC")
else()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -D_USE_MATH_DEFINES")
    set(CMAKE_WIN32_EXECUTABLE ON)
    set(GUI_TYPE WIN32)
ENDIF()

include_directories(
    ${Qt5Core_INCLUDE_DIRS}
    ${Qt5Widgets_INCLUDE_DIRS}
    ${Qt5Concurrent_INCLUDE_DIRS}
    ${Qt5PrintSupport_INCLUDE_DIRS}
    ${Qt5Xml_INCLUDE_DIRS}
    ${Qt5WebSockets_INCLUDE_DIRS}
    ${Qt5Svg_INCLUDE_DIRS}
    ${Qt5OpenGL_INCLUDE_DIRS}
    ./3rdparty/
    ./3rdparty/color_widgets/include
    ./3rdparty/Qt-Advanced-Docking/include
    ./3rdparty/qwt/src
    ./3rdparty/sol
    ./3rdparty/lua-5.4.3/src
    ./3rdparty/QCodeEditor/include
    ./3rdparty/lz4-1.9.4
    ./3rdparty/zstd-1.5.5
)

#########################  BASE library  ####################################

set(PLOTJUGGLER_BASE_SRC
    plotjuggler_base/src/plotdata.cpp
    plotjuggler_base/src/datastreamer_base.cpp
    plotjuggler_base/src/transform_function.cpp
    plotjuggler_base/src/plotwidget_base.cpp
    plotjuggler_base/src/plotzoomer.cpp
    plotjuggler_base/src/plotmagnifier.cpp
    plotjuggler_base/src/plotlegend.cpp
    plotjuggler_base/src/plotpanner.cpp
    plotjuggler_base/src/timeseries_qwt.cpp
    plotjuggler_base/src/reactive_function.cpp
)

qt5_wrap_cpp(PLOTJUGGLER_BASE_MOCS
  plotjuggler_base/include/PlotJuggler/dataloader_base.h
  plotjuggler_base/include/PlotJuggler/statepublisher_base.h
  plotjuggler_base/include/PlotJuggler/toolbox_base.h
  plotjuggler_base/include/PlotJuggler/datastreamer_base.h
  plotjuggler_base/include/PlotJuggler/transform_function.h
  plotjuggler_base/include/PlotJuggler/plotwidget_base.h
)

if (BASE_AS_SHARED)
    add_library(plotjuggler_base SHARED
        ${PLOTJUGGLER_BASE_SRC}
        ${PLOTJUGGLER_BASE_MOCS}
        )
    target_link_libraries(plotjuggler_base PRIVATE lua_objects plotjuggler_qwt_objects)
else()
    add_library(plotjuggler_base STATIC
        ${PLOTJUGGLER_BASE_SRC}
        ${PLOTJUGGLER_BASE_MOCS}
        )
endif()

# target_link_libraries(plotjuggler_base plotjuggler_qwt)

target_include_directories(plotjuggler_base INTERFACE
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
  $<INSTALL_INTERFACE:include>
)

#########################  INSTALL  ####################################

if(COMPILING_WITH_CATKIN)

    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_LIB_DESTINATION})
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_BIN_DESTINATION})
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_BIN_DESTINATION})
    set(PJ_PLUGIN_INSTALL_DIRECTORY ${CATKIN_PACKAGE_BIN_DESTINATION} )

elseif(COMPILING_WITH_AMENT)

    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
    set(PJ_PLUGIN_INSTALL_DIRECTORY lib/${PROJECT_NAME} )

    ament_export_targets(
        ${PROJECT_NAME}Targets
        export_plotjuggler_qwt
        HAS_LIBRARY_TARGET)
    ament_package()

else()

    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
    set(PJ_PLUGIN_INSTALL_DIRECTORY bin)

endif()

set(DESKTOP_ICON_DIR "${CMAKE_INSTALL_PREFIX}/share/icons")

install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/PlotJuggler.desktop
        DESTINATION  "${CMAKE_INSTALL_PREFIX}/share/applications"  )

install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/plotjuggler.svg
        DESTINATION ${DESKTOP_ICON_DIR}  )

######################## Main App, Libraries and Plugins ###################################

add_subdirectory( 3rdparty/qwt/src )
add_subdirectory( 3rdparty/lz4-1.9.4 )
add_subdirectory( 3rdparty/zstd-1.5.5 )
add_subdirectory( 3rdparty/QCodeEditor )
add_subdirectory( 3rdparty/color_widgets )
add_subdirectory( 3rdparty/Qt-Advanced-Docking )
add_subdirectory( 3rdparty/lua-5.4.3 )

if (NOT WIN32)
  add_subdirectory( 3rdparty/backward-cpp )
endif()

add_subdirectory( plotjuggler_app )

add_subdirectory( plotjuggler_plugins/DataLoadCSV )
add_subdirectory( plotjuggler_plugins/DataLoadMCAP )
add_subdirectory( plotjuggler_plugins/DataLoadParquet )
add_subdirectory( plotjuggler_plugins/DataLoadULog )

add_subdirectory( plotjuggler_plugins/DataStreamSample )
add_subdirectory( plotjuggler_plugins/DataStreamWebsocket )
add_subdirectory( plotjuggler_plugins/DataStreamUDP )
add_subdirectory( plotjuggler_plugins/DataStreamMQTT )
add_subdirectory( plotjuggler_plugins/DataStreamZMQ )

add_subdirectory( plotjuggler_plugins/StatePublisherCSV )
add_subdirectory( plotjuggler_plugins/VideoViewer )

add_subdirectory( plotjuggler_plugins/ToolboxQuaternion )
add_subdirectory( plotjuggler_plugins/ToolboxFFT )
add_subdirectory( plotjuggler_plugins/ToolboxLuaEditor )

add_subdirectory( plotjuggler_plugins/ParserProtobuf )
add_subdirectory( plotjuggler_plugins/ParserROS )
add_subdirectory( plotjuggler_plugins/ParserDataTamer )
add_subdirectory( plotjuggler_plugins/ParserLineInflux )

add_subdirectory( plotjuggler_plugins/PluginsZcm )

# Install targets

install(
     TARGETS
        plotjuggler_base
     EXPORT ${PROJECT_NAME}Targets
     LIBRARY DESTINATION lib
     ARCHIVE DESTINATION lib
     RUNTIME DESTINATION bin
     INCLUDES DESTINATION include)

install(DIRECTORY plotjuggler_base/include/ DESTINATION include )

export(PACKAGE ${PROJECT_NAME})

if(NOT COMPILING_WITH_AMENT AND NOT COMPILING_WITH_CATKIN)

    include(GNUInstallDirs)

    set(PJ_CMAKECONFIG_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME})

    install(
      EXPORT ${PROJECT_NAME}Targets
      FILE ${PROJECT_NAME}Targets.cmake
      DESTINATION ${PJ_CMAKECONFIG_INSTALL_DIR}
    )

    include(CMakePackageConfigHelpers)

    set(PJ_INCLUDE_INSTALL_DIR include)

    configure_package_config_file(
      ${CMAKE_CURRENT_SOURCE_DIR}/cmake/Config.cmake.in
      ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake
      INSTALL_DESTINATION ${PJ_CMAKECONFIG_INSTALL_DIR}
      PATH_VARS PJ_INCLUDE_INSTALL_DIR
    )

    # This requires to declare the project version in the project() macro
    write_basic_package_version_file(
     "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake"
     VERSION ${PROJECT_VERSION}
     COMPATIBILITY SameMajorVersion
    )

    message (STATUS "CMAKE_CURRENT_BINARY_DIR = ${CMAKE_CURRENT_BINARY_DIR}")

    install(
      FILES
        ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake
        ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
      DESTINATION ${PJ_CMAKECONFIG_INSTALL_DIR}
    )

endif()

=== requirements.txt ===
numpy==1.23.2
pyzmq==23.2.1
autopep8==1.7.0

=== plotjuggler_app/CMakeLists.txt ===

set (CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

include_directories( ./ ../  ../include )

QT5_ADD_RESOURCES (RES_SRC  resource.qrc )

QT5_WRAP_UI ( UI_SRC
    aboutdialog.ui
    mainwindow.ui

    support_dialog.ui
    curvelist_panel.ui
    preferences_dialog.ui
    suggest_dialog.ui
    new_release_dialog.ui
    changelog_dialog.ui
    multifile_prefix.ui
    colormap_editor.ui
    colormap_selector.ui
    statistics_dialog.ui

    plot_docker_toolbar.ui
    plotwidget_editor.ui

    transforms/function_editor.ui
    transforms/function_editor_help.ui
    transforms/transform_selector.ui

    transforms/first_derivative.ui
    transforms/moving_average_filter.ui
    transforms/moving_variance.ui
    transforms/moving_rms.ui
    transforms/outlier_removal.ui
    transforms/integral_transform.ui
    transforms/scale_transform.ui
    transforms/samples_count.ui

    cheatsheet/cheatsheet_dialog.ui
    )

SET( PLOtJUGGLER_SRC

    cheatsheet/cheatsheet_dialog.cpp

    customtracker.cpp
    multifile_prefix.cpp
    colormap_editor.cpp
    colormap_selector.cpp

    color_map.cpp
    curvelist_panel.cpp
    curvelist_view.cpp
    curvetree_view.cpp
    dummy_data.cpp
    main.cpp
    mainwindow.cpp
    messageparser_base.cpp
    menubar.cpp
    new_release_dialog.cpp
#    plotlegend.cpp
    plotwidget.cpp
    plotwidget_editor.cpp
    plotwidget_transforms.cpp
    plot_docker.cpp
    plot_docker_toolbar.cpp
    preferences_dialog.cpp
    point_series_xy.cpp
#    plotzoomer.cpp
    plot_background.cpp
    statistics_dialog.cpp

    suggest_dialog.cpp
#    timeseries_qwt.cpp
    tabbedplotwidget.cpp
    tab_widget.h
    tree_completer.h

    transforms/custom_function.cpp
    transforms/function_editor.cpp
    transforms/transform_selector.cpp
    transforms/lua_custom_function.cpp
    transforms/moving_average_filter.cpp
    transforms/moving_rms.cpp
    transforms/moving_variance.cpp
    transforms/outlier_removal.cpp
    transforms/integral_transform.cpp
    transforms/absolute_transform.cpp
    transforms/samples_count.cpp

    transforms/first_derivative.cpp
    transforms/scale_transform.cpp

    utils.h
    utils.cpp

    mainwindow.h
    realslider.h

    nlohmann_parsers.cpp
    )

add_executable(plotjuggler
    ${PLOtJUGGLER_SRC}
    ${RES_SRC}
    ${UI_SRC}
    ${BACKWARD_ENABLE} )

if (NOT WIN32)
    add_backward(plotjuggler)
endif()

target_link_libraries(plotjuggler
    ${QT_LINK_LIBRARIES}
    colorwidgets
    lua_static
    qt_advanced_docking
    plotjuggler_base
    plotjuggler_qwt
    QCodeEditor
    )

if(COMPILING_WITH_CATKIN)

    target_link_libraries(plotjuggler ${catkin_LIBRARIES} )

    install(TARGETS plotjuggler
        ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
        LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
        RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
        )

elseif(COMPILING_WITH_AMENT)

    ament_target_dependencies(plotjuggler ament_index_cpp rclcpp)

    install(TARGETS plotjuggler
        DESTINATION lib/${PROJECT_NAME} )
else()
    install(TARGETS plotjuggler
        DESTINATION bin  )
endif()

=== 3rdparty/QCodeEditor/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(QCodeEditor)

set(CMAKE_CXX_STANDARD 11)

set(RESOURCES_FILE
    resources/qcodeeditor_resources.qrc
)

set(INCLUDE_FILES
    include/QHighlightRule
    include/QHighlightBlockRule
    include/QCodeEditor
    include/QCXXHighlighter
    include/QLineNumberArea
    include/QStyleSyntaxHighlighter
    include/QSyntaxStyle
    include/QGLSLCompleter
    include/QGLSLHighlighter
    include/QLanguage
    include/QXMLHighlighter
    include/QJSONHighlighter
    include/QLuaCompleter
    include/QLuaHighlighter
    include/QPythonHighlighter
    include/QFramedTextAttribute
    include/internal/QHighlightRule.hpp
    include/internal/QHighlightBlockRule.hpp
    include/internal/QCodeEditor.hpp
    include/internal/QCXXHighlighter.hpp
    include/internal/QCSVHighlighter.hpp
    include/internal/QLineNumberArea.hpp
    include/internal/QStyleSyntaxHighlighter.hpp
    include/internal/QSyntaxStyle.hpp
    include/internal/QGLSLCompleter.hpp
    include/internal/QGLSLHighlighter.hpp
    include/internal/QLanguage.hpp
    include/internal/QXMLHighlighter.hpp
    include/internal/QJSONHighlighter.hpp
    include/internal/QLuaCompleter.hpp
    include/internal/QLuaHighlighter.hpp
    include/internal/QPythonCompleter.hpp
    include/internal/QPythonHighlighter.hpp
    include/internal/QFramedTextAttribute.hpp
)

set(SOURCE_FILES
    src/internal/QCodeEditor.cpp
    src/internal/QLineNumberArea.cpp
    src/internal/QCXXHighlighter.cpp
    src/internal/QCSVHighlighter.cpp
    src/internal/QSyntaxStyle.cpp
    src/internal/QStyleSyntaxHighlighter.cpp
    src/internal/QGLSLCompleter.cpp
    src/internal/QGLSLHighlighter.cpp
    src/internal/QLanguage.cpp
    src/internal/QXMLHighlighter.cpp
    src/internal/QJSONHighlighter.cpp
    src/internal/QLuaCompleter.cpp
    src/internal/QLuaHighlighter.cpp
    src/internal/QPythonCompleter.cpp
    src/internal/QPythonHighlighter.cpp
    src/internal/QFramedTextAttribute.cpp
)

# Create code for QObjects
set(CMAKE_AUTOMOC On)

# Create code from resource files
set(CMAKE_AUTORCC ON)

# Find includes in corresponding build directories
find_package(Qt5Core    CONFIG REQUIRED)
find_package(Qt5Widgets CONFIG REQUIRED)
find_package(Qt5Gui     CONFIG REQUIRED)

add_library(QCodeEditor STATIC
    ${RESOURCES_FILE}
    ${SOURCE_FILES}
    ${INCLUDE_FILES}
)

target_include_directories(QCodeEditor PUBLIC
    include
)

if(CMAKE_COMPILER_IS_GNUCXX)
    target_compile_options(QCodeEditor
		PRIVATE
		-ansi
		-pedantic
		-Wall
		-Wextra
		-Weffc++
		-Woverloaded-virtual
		-Winit-self
		-std=c++11
		-Wunreachable-code
	)
endif(CMAKE_COMPILER_IS_GNUCXX)

target_link_libraries(QCodeEditor
    Qt5::Core
    Qt5::Widgets
    Qt5::Gui
)

=== 3rdparty/Qt-Advanced-Docking/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(QtADS LANGUAGES CXX)

include_directories(include/Qads)

find_package(Qt5 5.5 COMPONENTS Core Gui Widgets REQUIRED)
if (UNIX AND NOT APPLE)
        find_package(Qt5 5.5 COMPONENTS X11Extras REQUIRED)
endif()

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(ads_SRCS
    src/ads_globals.cpp
    src/DockAreaTabBar.cpp
    src/DockAreaTitleBar.cpp
    src/DockAreaWidget.cpp
    src/DockContainerWidget.cpp
    src/DockManager.cpp
    src/DockOverlay.cpp
    src/DockSplitter.cpp
    src/DockWidget.cpp
    src/DockWidgetTab.cpp
    src/DockingStateReader.cpp
    src/DockFocusController.cpp
    src/ElidingLabel.cpp
    src/FloatingDockContainer.cpp
    src/FloatingDragPreview.cpp
    src/IconProvider.cpp
    src/DockComponentsFactory.cpp

    src/ads.qrc

    include/Qads/ads_globals.h
    include/Qads/DockAreaTabBar.h
    include/Qads/DockAreaTitleBar.h
    include/Qads/DockAreaTitleBar_p.h
    include/Qads/DockAreaWidget.h
    include/Qads/DockContainerWidget.h
    include/Qads/DockManager.h
    include/Qads/DockOverlay.h
    include/Qads/DockSplitter.h
    include/Qads/DockWidget.h
    include/Qads/DockWidgetTab.h
    include/Qads/DockingStateReader.h
    include/Qads/DockFocusController.h
    include/Qads/ElidingLabel.h
    include/Qads/FloatingDockContainer.h
    include/Qads/FloatingDragPreview.h
    include/Qads/IconProvider.h
    include/Qads/DockComponentsFactory.h
)

if (UNIX AND NOT APPLE)
    set(ads_SRCS
        src/linux/FloatingWidgetTitleBar.cpp
        ${ads_SRCS}
    )
endif()


add_library(qt_advanced_docking STATIC ${ads_SRCS} )
target_compile_definitions(qt_advanced_docking PUBLIC ADS_STATIC)

target_link_libraries(qt_advanced_docking PUBLIC Qt5::Core Qt5::Gui Qt5::Widgets)

if(UNIX AND NOT APPLE)
    target_link_libraries(qt_advanced_docking PUBLIC Qt5::X11Extras)
        target_link_libraries(qt_advanced_docking PRIVATE xcb)
endif()

set_target_properties(qt_advanced_docking PROPERTIES
    AUTOMOC ON
    AUTORCC ON
    CXX_STANDARD 14
    CXX_STANDARD_REQUIRED ON
    CXX_EXTENSIONS OFF
)

=== 3rdparty/backward-cpp/CMakeLists.txt ===
#
# CMakeLists.txt
# Copyright 2013 Google Inc. All Rights Reserved.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

cmake_minimum_required(VERSION 3.0)
project(backward CXX)

# Introduce variables:
# * CMAKE_INSTALL_LIBDIR
# * CMAKE_INSTALL_BINDIR
# * CMAKE_INSTALL_INCLUDEDIR
include(GNUInstallDirs)

include(BackwardConfig.cmake)

# check if compiler is nvcc or nvcc_wrapper
set(COMPILER_IS_NVCC false)
get_filename_component(COMPILER_NAME ${CMAKE_CXX_COMPILER} NAME)
if (COMPILER_NAME MATCHES "^nvcc")
  set(COMPILER_IS_NVCC true)
endif()

if (DEFINED ENV{OMPI_CXX} OR DEFINED ENV{MPICH_CXX})
   if ( ($ENV{OMPI_CXX} MATCHES "nvcc") OR ($ENV{MPICH_CXX} MATCHES "nvcc") )
     set(COMPILER_IS_NVCC true)
   endif()
endif()

# set CXX standard
set(CMAKE_CXX_STANDARD_REQUIRED True)
set(CMAKE_CXX_STANDARD 11)
if (${COMPILER_IS_NVCC})
  # GNU CXX extensions are not supported by nvcc
  set(CMAKE_CXX_EXTENSIONS OFF)
endif()

###############################################################################
# COMPILER FLAGS
###############################################################################

if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR CMAKE_COMPILER_IS_GNUCXX)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra")
	if (NOT ${COMPILER_IS_NVCC})
	  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pedantic-errors")
	endif()
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g")
endif()

###############################################################################
# BACKWARD OBJECT
###############################################################################

add_library(backward_object OBJECT backward.cpp)
target_compile_definitions(backward_object PRIVATE ${BACKWARD_DEFINITIONS})
target_include_directories(backward_object PRIVATE ${BACKWARD_INCLUDE_DIRS})
set(BACKWARD_ENABLE $<TARGET_OBJECTS:backward_object> CACHE STRING
	"Link with this object to setup backward automatically")


###############################################################################
# BACKWARD LIBRARY (Includes backward.cpp)
###############################################################################

add_library(backward STATIC backward.cpp)
target_compile_definitions(backward PUBLIC ${BACKWARD_DEFINITIONS})
target_include_directories(backward PUBLIC ${BACKWARD_INCLUDE_DIRS})

=== 3rdparty/color_widgets/CMakeLists.txt ===

SET( COLOR_WIDGETS_SRC

    include/color_names.hpp
    include/color_palette.hpp
    include/color_utils.hpp
    include/color_preview.hpp
    include/color_wheel.hpp
    include/swatch.hpp

    src/color_names.cpp
    src/color_palette.cpp
    src/color_utils.cpp
    src/color_preview.cpp
    src/color_wheel.cpp
    src/swatch.cpp
    )

add_library(colorwidgets STATIC ${COLOR_WIDGETS_SRC})

target_link_libraries(colorwidgets Qt5::Widgets )

=== 3rdparty/lua-5.4.3/CMakeLists.txt ===
set(LUA_LIB_SRCS 
    ${CMAKE_CURRENT_SOURCE_DIR}/src/lapi.c 
    ${CMAKE_CURRENT_SOURCE_DIR}/src/lcode.c 
    ${CMAKE_CURRENT_SOURCE_DIR}/src/lctype.c 
    ${CMAKE_CURRENT_SOURCE_DIR}/src/ldebug.c 
    ${CMAKE_CURRENT_SOURCE_DIR}/src/ldo.c 
    ${CMAKE_CURRENT_SOURCE_DIR}/src/ldump.c 
    ${CMAKE_CURRENT_SOURCE_DIR}/src/lfunc.c 
    ${CMAKE_CURRENT_SOURCE_DIR}/src/lgc.c 
    ${CMAKE_CURRENT_SOURCE_DIR}/src/llex.c 
    ${CMAKE_CURRENT_SOURCE_DIR}/src/lmem.c 
    ${CMAKE_CURRENT_SOURCE_DIR}/src/lobject.c 
    ${CMAKE_CURRENT_SOURCE_DIR}/src/lopcodes.c 
    ${CMAKE_CURRENT_SOURCE_DIR}/src/lparser.c 
    ${CMAKE_CURRENT_SOURCE_DIR}/src/lstate.c 
    ${CMAKE_CURRENT_SOURCE_DIR}/src/lstring.c 
    ${CMAKE_CURRENT_SOURCE_DIR}/src/ltable.c 
    ${CMAKE_CURRENT_SOURCE_DIR}/src/ltm.c 
    ${CMAKE_CURRENT_SOURCE_DIR}/src/lundump.c 
    ${CMAKE_CURRENT_SOURCE_DIR}/src/lvm.c 
    ${CMAKE_CURRENT_SOURCE_DIR}/src/lzio.c 
    ${CMAKE_CURRENT_SOURCE_DIR}/src/lauxlib.c 
    ${CMAKE_CURRENT_SOURCE_DIR}/src/lbaselib.c 
    ${CMAKE_CURRENT_SOURCE_DIR}/src/lcorolib.c 
    ${CMAKE_CURRENT_SOURCE_DIR}/src/ldblib.c 
    ${CMAKE_CURRENT_SOURCE_DIR}/src/liolib.c 
    ${CMAKE_CURRENT_SOURCE_DIR}/src/lmathlib.c 
    ${CMAKE_CURRENT_SOURCE_DIR}/src/loslib.c 
    ${CMAKE_CURRENT_SOURCE_DIR}/src/lstrlib.c 
    ${CMAKE_CURRENT_SOURCE_DIR}/src/ltablib.c 
    ${CMAKE_CURRENT_SOURCE_DIR}/src/lutf8lib.c 
    ${CMAKE_CURRENT_SOURCE_DIR}/src/loadlib.c 
    ${CMAKE_CURRENT_SOURCE_DIR}/src/linit.c
    )
set(LUA_LIB_INCLUDE ${CMAKE_CURRENT_SOURCE_DIR}/src)

if(CMAKE_C_COMPILER_ID MATCHES "GNU|Clang|AppleClang")
    add_compile_options(-fPIC)
endif()

add_library(lua_static STATIC
    ${LUA_LIB_SRCS}
    ${CMAKE_CURRENT_SOURCE_DIR}/src/lua.c
)
target_include_directories(lua_static PUBLIC ${LUA_LIB_INCLUDE})

add_library(lua_objects OBJECT ${LUA_LIB_SRCS})

if ( NOT WIN32 )
    set(LUA_DEFINITIONS LUA_USE_POSIX)
endif()

if(EMSCRIPTEN)
    unset(LUA_DEFINITIONS)
endif()
target_compile_definitions(lua_static PUBLIC ${LUA_DEFINITIONS})

=== 3rdparty/lz4-1.9.4/CMakeLists.txt ===

PROJECT(lz4 LANGUAGES C CXX VERSION 1.9.3)

set(CMAKE_POSITION_INDEPENDENT_CODE ON)

add_library(lz4_static STATIC
    lz4.c
    lz4hc.c
    lz4frame.c
    xxhash.c
    )

=== 3rdparty/zstd-1.5.5/CMakeLists.txt ===
# ################################################################
# Copyright (c) Meta Platforms, Inc. and affiliates.
# All rights reserved.
#
# This source code is licensed under both the BSD-style license (found in the
# LICENSE file in the root directory of this source tree) and the GPLv2 (found
# in the COPYING file in the root directory of this source tree).
# ################################################################

project(libzstd C ASM)

set(CMAKE_INCLUDE_CURRENT_DIR TRUE)
option(ZSTD_BUILD_COMPRESSION "BUILD COMPRESSION MODULE" ON)
option(ZSTD_BUILD_DECOMPRESSION "BUILD DECOMPRESSION MODULE" ON)
option(ZSTD_BUILD_DICTBUILDER "BUILD DICTBUILDER MODULE" ON)

set(ZSTDLIB_VISIBLE "" CACHE STRING "Visibility for ZSTDLIB API")
set(ZSTDERRORLIB_VISIBLE "" CACHE STRING "Visibility for ZSTDERRORLIB_VISIBLE API")
set(ZDICTLIB_VISIBLE "" CACHE STRING "Visibility for ZDICTLIB_VISIBLE API")
set(ZSTDLIB_STATIC_API "" CACHE STRING "Visibility for ZSTDLIB_STATIC_API API")
set(ZDICTLIB_STATIC_API "" CACHE STRING "Visibility for ZDICTLIB_STATIC_API API")

set_property(CACHE ZSTDLIB_VISIBLE PROPERTY STRINGS "" "hidden" "default" "protected" "internal")
set_property(CACHE ZSTDERRORLIB_VISIBLE PROPERTY STRINGS "" "hidden" "default" "protected" "internal")
set_property(CACHE ZDICTLIB_VISIBLE PROPERTY STRINGS "" "hidden" "default" "protected" "internal")
set_property(CACHE ZSTDLIB_STATIC_API PROPERTY STRINGS "" "hidden" "default" "protected" "internal")
set_property(CACHE ZDICTLIB_STATIC_API PROPERTY STRINGS "" "hidden" "default" "protected" "internal")

set(Sources src/zstd.c)

# Explicitly set the language to C for all files, including ASM files.
# Our assembly expects to be compiled by a C compiler, and is only enabled for
# __GNUC__ compatible compilers. Otherwise all the ASM code is disabled by
# macros.
if(NOT CMAKE_ASM_COMPILER STREQUAL CMAKE_C_COMPILER)
    set_source_files_properties(${Sources} PROPERTIES LANGUAGE C)
endif()

macro (add_definition target var)
    if (NOT ("${${var}}" STREQUAL ""))
        set_property(TARGET ${target} APPEND PROPERTY COMPILE_DEFINITIONS "${var}=__attribute__((visibility(\"${${var}}\")))")
    endif ()
endmacro ()

# Split project to static and shared libraries build
set(library_targets)

    add_library(libzstd_static STATIC ${Sources} ${Headers})
    list(APPEND library_targets libzstd_static)
    if (ZSTD_MULTITHREAD_SUPPORT)
        set_property(TARGET libzstd_static APPEND PROPERTY COMPILE_DEFINITIONS "ZSTD_MULTITHREAD")
        if (UNIX)
            target_link_libraries(libzstd_static ${THREADS_LIBS})
        endif ()
    endif ()
    add_definition(libzstd_static ZSTDLIB_VISIBLE)
    add_definition(libzstd_static ZSTDERRORLIB_VISIBLE)
    add_definition(libzstd_static ZDICTLIB_VISIBLE)
    add_definition(libzstd_static ZSTDLIB_STATIC_API)
    add_definition(libzstd_static ZDICTLIB_STATIC_API)

# Add specific compile definitions for MSVC project
if (MSVC)
    set_property(TARGET libzstd_static APPEND PROPERTY COMPILE_DEFINITIONS "ZSTD_HEAPMODE=0;_CRT_SECURE_NO_WARNINGS")
endif ()

# With MSVC static library needs to be renamed to avoid conflict with import library
if (MSVC OR (WIN32 AND CMAKE_CXX_COMPILER_ID STREQUAL "Clang" AND NOT MINGW))
    set(STATIC_LIBRARY_BASE_NAME zstd_static)
else ()
    set(STATIC_LIBRARY_BASE_NAME zstd)
endif ()

# Define static and shared library names
set_target_properties(
            libzstd_static
            PROPERTIES
            POSITION_INDEPENDENT_CODE On
            OUTPUT_NAME ${STATIC_LIBRARY_BASE_NAME})

=== plotjuggler_plugins/DataLoadCSV/CMakeLists.txt ===

include_directories(  ../ )

add_definitions(${QT_DEFINITIONS})
add_definitions(-DQT_PLUGIN)

QT5_WRAP_UI ( UI_SRC
    dataload_csv.ui
    datetimehelp.ui
    )

SET( SRC
    dataload_csv.cpp
    datetimehelp.cpp
    )

add_library(DataLoadCSV SHARED ${SRC} ${UI_SRC}  )
target_link_libraries(DataLoadCSV
    ${Qt5Widgets_LIBRARIES}
    ${Qt5Xml_LIBRARIES}
    plotjuggler_base
    QCodeEditor)


install(TARGETS DataLoadCSV DESTINATION ${PJ_PLUGIN_INSTALL_DIRECTORY}  )

=== plotjuggler_plugins/DataLoadMCAP/CMakeLists.txt ===
add_definitions(${QT_DEFINITIONS})
add_definitions(-DQT_PLUGIN)

QT5_WRAP_UI ( UI_SRC  dialog_mcap.ui  )

add_library(DataLoadMCAP SHARED
    mcap.cpp
    dataload_mcap.cpp
    dialog_mcap.cpp
    ${UI_SRC}  )

target_link_libraries(DataLoadMCAP
    ${Qt5Widgets_LIBRARIES}
    ${Qt5Xml_LIBRARIES}
    libzstd_static
    lz4_static
    plotjuggler_base )

install(TARGETS DataLoadMCAP DESTINATION ${PJ_PLUGIN_INSTALL_DIRECTORY}  )

## ros-one-plotjuggler 3.9.2-21jammy.20251023.0000

=== debian/changelog ===
ros-one-plotjuggler (3.9.2-21jammy.20251023.0000) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Davide Faconti <davide.faconti@gmail.com>  Thu, 23 Oct 2025 00:00:49 +0000

ros-one-plotjuggler (3.9.2-0jammy) jammy; urgency=high

  * Save NlohmannParser (JSON) settings (#971 <https://github.com/facontidavide/PlotJuggler/issues/971>)
  * Fix infinite streaming buffer regression (#953 <https://github.com/facontidavide/PlotJuggler/issues/953>)
    Co-authored-by: paul <mailto:paul@WorkLaptop>
  * fix warning and includes
  * updated fastcdr
  * Added support for empty messages (#960 <https://github.com/facontidavide/PlotJuggler/issues/960>)
  * add a parser for the Line Protocol (InfluxDB)
  * Fixed the value dereference for ULog information messages (#946 <https://github.com/facontidavide/PlotJuggler/issues/946>)
  * adding pre-commit check in CI
  * fmt updated to 10.2.1
  * apply clang format and move PlotJuggler/fmt
  * moved KissFFT
  * pre-commit
  * Contributors: Davide Faconti, Declan Mullen, Jonathan, Michel Jansson, Paul, ubaldot

 -- Davide Faconti <davide.faconti@gmail.com>  Wed, 08 May 2024 00:00:00 -0000

ros-one-plotjuggler (3.9.1-0jammy) jammy; urgency=high

  * embed zstd 1.5.5
  * updated lz4 1.9.4
  * PlotJuggler with Fast-CDR-2.x.x (#932 <https://github.com/facontidavide/PlotJuggler/issues/932>)
  * fix ROS2 parser bug
  * fix #935 <https://github.com/facontidavide/PlotJuggler/issues/935> and #934 <https://github.com/facontidavide/PlotJuggler/issues/934>
  * Add Sample Count to transforms
  * fix compilation in Windows
  * Contributors: Davide Faconti, Manuel Valch

 -- Davide Faconti <davide.faconti@gmail.com>  Tue, 20 Feb 2024 00:00:00 -0000

ros-one-plotjuggler (3.9.0-0jammy) jammy; urgency=high

  * new status bar with messages from the internet
  * Merge branch 'ulog_improvement'
  * new memes
  * quick file reload!
  * transforms have now default values from previous
  * add icons to dialog Delete Series
  * cleanup and fix ULOG
  * add ULOG parameters as 1 sample timeseries
  * fix issue #929 <https://github.com/facontidavide/PlotJuggler/issues/929> : numerical truncation
  * bypass truncation check
  * Fixed parsing JointState messages (#927 <https://github.com/facontidavide/PlotJuggler/issues/927>)
  * Contributors: Davide Faconti, Martin Pecka

 -- Davide Faconti <davide.faconti@gmail.com>  Sun, 04 Feb 2024 00:00:00 -0000

ros-one-plotjuggler (3.8.10-0jammy) jammy; urgency=high

  * Fix issue #924: crash when loading rosbag with std_msgs/Empty
  * Allow ZMQ plugin to work as server
  * Link against Abseil for macOS builds & improve macOS compile docs #845 <https://github.com/facontidavide/PlotJuggler/issues/845> (#905 <https://github.com/facontidavide/PlotJuggler/issues/905>)
  * fix issue in CSV #926 <https://github.com/facontidavide/PlotJuggler/issues/926>
  * attempt to match ambiguous ros msg within package before using external known type (#922 <https://github.com/facontidavide/PlotJuggler/issues/922>)
  * Contributors: Davide Faconti, Manuel Valch, Will MacCormack, rugged-robotics

 -- Davide Faconti <davide.faconti@gmail.com>  Fri, 26 Jan 2024 00:00:00 -0000

ros-one-plotjuggler (3.8.9-0jammy) jammy; urgency=high

  * fix bug #924 <https://github.com/facontidavide/PlotJuggler/issues/924> (messages with no fields)
  * Bugfix: Wrong curvestyle is preselected (#921 <https://github.com/facontidavide/PlotJuggler/issues/921>)
  * Contributors: Davide Faconti, Simon Sagmeister

 -- Davide Faconti <davide.faconti@gmail.com>  Wed, 24 Jan 2024 00:00:00 -0000

ros-one-plotjuggler (3.8.8-0jammy) jammy; urgency=high

  * new update screen
  * Update README.md
  * dig diagnostic messages
  * fix snap in CI
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Thu, 18 Jan 2024 00:00:00 -0000

ros-one-plotjuggler (3.8.7-0jammy) jammy; urgency=high

  * add "prefix and merge" checkbox
  * fix warning "transparent.png"
  * fix issue #912 <https://github.com/facontidavide/PlotJuggler/issues/912>
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Tue, 16 Jan 2024 00:00:00 -0000

ros-one-plotjuggler (3.8.6-0jammy) jammy; urgency=high

  * fix issue #906 <https://github.com/facontidavide/PlotJuggler/issues/906>: support nanoseconds timestamp in csv
  * fix issue #904 <https://github.com/facontidavide/PlotJuggler/issues/904>: wring ROS odometry parsing
  * add moving variance
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Tue, 09 Jan 2024 00:00:00 -0000

ros-one-plotjuggler (3.8.5-0jammy) jammy; urgency=high

  * fix issue #901 <https://github.com/facontidavide/PlotJuggler/issues/901>
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Wed, 03 Jan 2024 00:00:00 -0000

ros-one-plotjuggler (3.8.4-0jammy) jammy; urgency=high

  * critical bug fix: #864 <https://github.com/facontidavide/PlotJuggler/issues/864> #856 <https://github.com/facontidavide/PlotJuggler/issues/856>
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Wed, 20 Dec 2023 00:00:00 -0000

ros-one-plotjuggler (3.8.1-0jammy) jammy; urgency=high

  * data_tamer added to rosx_introspection
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Thu, 23 Nov 2023 00:00:00 -0000

ros-one-plotjuggler (3.8.0-0jammy) jammy; urgency=high

  * data_tamer updated
    This reverts commit 4ba24c591a9a84fbfb6c0329b787d73f98a2b23b.
  * CI updated
  * qwt updated
  * Merge pull request #869 <https://github.com/facontidavide/PlotJuggler/issues/869> from zdavkeos/step_interpolation
    Add "Steps" when drawing curves
  * Merge pull request #870 <https://github.com/facontidavide/PlotJuggler/issues/870> from MirkoFerrati/patch-3
    Fix missing '22' in the new snap core22 workflow
  * Fix missing '22' in the new snap core22 workflow


=== debian/control ===
Source: ros-one-plotjuggler
Section: misc
Priority: optional
Maintainer: Davide Faconti <davide.faconti@gmail.com>
Build-Depends: debhelper (>= 9.0.0), binutils-dev, libboost-all-dev, liblz4-dev, libprotobuf-dev, libprotoc-dev, libqt5opengl5-dev, libqt5svg5-dev, libqt5websockets5-dev, libqt5x11extras5-dev, libzmq3-dev, libzstd-dev, protobuf-compiler, qtbase5-dev, ros-one-catkin, ros-one-roscpp, ros-one-roslib
Homepage: https://github.com/facontidavide/PlotJuggler
Standards-Version: 3.9.2

Package: ros-one-plotjuggler
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, binutils-dev, libboost-all-dev, liblz4-dev, libprotobuf-dev, libprotoc-dev, libqt5opengl5-dev, libqt5svg5-dev, libqt5websockets5-dev, libqt5x11extras5-dev, libzmq3-dev, libzstd-dev, protobuf-compiler, qtbase5-dev, ros-one-roscpp, ros-one-roslib
Description: PlotJuggler: juggle with data

## ros-one-plotjuggler 3.9.2-21jammy.20260220.2101

=== debian/changelog ===
ros-one-plotjuggler (3.9.2-21jammy.20260220.2101) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Davide Faconti <davide.faconti@gmail.com>  Fri, 20 Feb 2026 21:01:32 +0000

=== debian/control ===
Source: ros-one-plotjuggler
Section: misc
Priority: optional
Maintainer: Davide Faconti <davide.faconti@gmail.com>
Build-Depends: debhelper (>= 9.0.0), binutils-dev, libboost-all-dev, liblz4-dev, libprotobuf-dev, libprotoc-dev, libqt5opengl5-dev, libqt5svg5-dev, libqt5websockets5-dev, libqt5x11extras5-dev, libzmq3-dev, libzstd-dev, lz4, protobuf-compiler, qtbase5-dev, ros-one-catkin, ros-one-roscpp, ros-one-roslib
Homepage: https://github.com/facontidavide/PlotJuggler
Standards-Version: 3.9.2

Package: ros-one-plotjuggler
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, binutils-dev, libboost-all-dev, liblz4-dev, libprotobuf-dev, libprotoc-dev, libqt5opengl5-dev, libqt5svg5-dev, libqt5websockets5-dev, libqt5x11extras5-dev, libzmq3-dev, libzstd-dev, lz4, protobuf-compiler, qtbase5-dev, ros-one-roscpp, ros-one-roslib
Description: PlotJuggler: juggle with data

## ros-one-plotjuggler 3.9.2-21noble.20251022.2358

=== debian/changelog ===
ros-one-plotjuggler (3.9.2-21noble.20251022.2358) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Davide Faconti <davide.faconti@gmail.com>  Wed, 22 Oct 2025 23:58:32 +0000

ros-one-plotjuggler (3.9.2-0noble) noble; urgency=high

  * Save NlohmannParser (JSON) settings (#971 <https://github.com/facontidavide/PlotJuggler/issues/971>)
  * Fix infinite streaming buffer regression (#953 <https://github.com/facontidavide/PlotJuggler/issues/953>)
    Co-authored-by: paul <mailto:paul@WorkLaptop>
  * fix warning and includes
  * updated fastcdr
  * Added support for empty messages (#960 <https://github.com/facontidavide/PlotJuggler/issues/960>)
  * add a parser for the Line Protocol (InfluxDB)
  * Fixed the value dereference for ULog information messages (#946 <https://github.com/facontidavide/PlotJuggler/issues/946>)
  * adding pre-commit check in CI
  * fmt updated to 10.2.1
  * apply clang format and move PlotJuggler/fmt
  * moved KissFFT
  * pre-commit
  * Contributors: Davide Faconti, Declan Mullen, Jonathan, Michel Jansson, Paul, ubaldot

 -- Davide Faconti <davide.faconti@gmail.com>  Wed, 08 May 2024 00:00:00 -0000

ros-one-plotjuggler (3.9.1-0noble) noble; urgency=high

  * embed zstd 1.5.5
  * updated lz4 1.9.4
  * PlotJuggler with Fast-CDR-2.x.x (#932 <https://github.com/facontidavide/PlotJuggler/issues/932>)
  * fix ROS2 parser bug
  * fix #935 <https://github.com/facontidavide/PlotJuggler/issues/935> and #934 <https://github.com/facontidavide/PlotJuggler/issues/934>
  * Add Sample Count to transforms
  * fix compilation in Windows
  * Contributors: Davide Faconti, Manuel Valch

 -- Davide Faconti <davide.faconti@gmail.com>  Tue, 20 Feb 2024 00:00:00 -0000

ros-one-plotjuggler (3.9.0-0noble) noble; urgency=high

  * new status bar with messages from the internet
  * Merge branch 'ulog_improvement'
  * new memes
  * quick file reload!
  * transforms have now default values from previous
  * add icons to dialog Delete Series
  * cleanup and fix ULOG
  * add ULOG parameters as 1 sample timeseries
  * fix issue #929 <https://github.com/facontidavide/PlotJuggler/issues/929> : numerical truncation
  * bypass truncation check
  * Fixed parsing JointState messages (#927 <https://github.com/facontidavide/PlotJuggler/issues/927>)
  * Contributors: Davide Faconti, Martin Pecka

 -- Davide Faconti <davide.faconti@gmail.com>  Sun, 04 Feb 2024 00:00:00 -0000

ros-one-plotjuggler (3.8.10-0noble) noble; urgency=high

  * Fix issue #924: crash when loading rosbag with std_msgs/Empty
  * Allow ZMQ plugin to work as server
  * Link against Abseil for macOS builds & improve macOS compile docs #845 <https://github.com/facontidavide/PlotJuggler/issues/845> (#905 <https://github.com/facontidavide/PlotJuggler/issues/905>)
  * fix issue in CSV #926 <https://github.com/facontidavide/PlotJuggler/issues/926>
  * attempt to match ambiguous ros msg within package before using external known type (#922 <https://github.com/facontidavide/PlotJuggler/issues/922>)
  * Contributors: Davide Faconti, Manuel Valch, Will MacCormack, rugged-robotics

 -- Davide Faconti <davide.faconti@gmail.com>  Fri, 26 Jan 2024 00:00:00 -0000

ros-one-plotjuggler (3.8.9-0noble) noble; urgency=high

  * fix bug #924 <https://github.com/facontidavide/PlotJuggler/issues/924> (messages with no fields)
  * Bugfix: Wrong curvestyle is preselected (#921 <https://github.com/facontidavide/PlotJuggler/issues/921>)
  * Contributors: Davide Faconti, Simon Sagmeister

 -- Davide Faconti <davide.faconti@gmail.com>  Wed, 24 Jan 2024 00:00:00 -0000

ros-one-plotjuggler (3.8.8-0noble) noble; urgency=high

  * new update screen
  * Update README.md
  * dig diagnostic messages
  * fix snap in CI
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Thu, 18 Jan 2024 00:00:00 -0000

ros-one-plotjuggler (3.8.7-0noble) noble; urgency=high

  * add "prefix and merge" checkbox
  * fix warning "transparent.png"
  * fix issue #912 <https://github.com/facontidavide/PlotJuggler/issues/912>
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Tue, 16 Jan 2024 00:00:00 -0000

ros-one-plotjuggler (3.8.6-0noble) noble; urgency=high

  * fix issue #906 <https://github.com/facontidavide/PlotJuggler/issues/906>: support nanoseconds timestamp in csv
  * fix issue #904 <https://github.com/facontidavide/PlotJuggler/issues/904>: wring ROS odometry parsing
  * add moving variance
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Tue, 09 Jan 2024 00:00:00 -0000

ros-one-plotjuggler (3.8.5-0noble) noble; urgency=high

  * fix issue #901 <https://github.com/facontidavide/PlotJuggler/issues/901>
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Wed, 03 Jan 2024 00:00:00 -0000

ros-one-plotjuggler (3.8.4-0noble) noble; urgency=high

  * critical bug fix: #864 <https://github.com/facontidavide/PlotJuggler/issues/864> #856 <https://github.com/facontidavide/PlotJuggler/issues/856>
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Wed, 20 Dec 2023 00:00:00 -0000

ros-one-plotjuggler (3.8.1-0noble) noble; urgency=high

  * data_tamer added to rosx_introspection
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Thu, 23 Nov 2023 00:00:00 -0000

ros-one-plotjuggler (3.8.0-0noble) noble; urgency=high

  * data_tamer updated
    This reverts commit 4ba24c591a9a84fbfb6c0329b787d73f98a2b23b.
  * CI updated
  * qwt updated
  * Merge pull request #869 <https://github.com/facontidavide/PlotJuggler/issues/869> from zdavkeos/step_interpolation
    Add "Steps" when drawing curves
  * Merge pull request #870 <https://github.com/facontidavide/PlotJuggler/issues/870> from MirkoFerrati/patch-3
    Fix missing '22' in the new snap core22 workflow
  * Fix missing '22' in the new snap core22 workflow


=== debian/control ===
Source: ros-one-plotjuggler
Section: misc
Priority: optional
Maintainer: Davide Faconti <davide.faconti@gmail.com>
Build-Depends: debhelper (>= 9.0.0), binutils-dev, cppzmq-dev, libboost-all-dev, liblz4-dev, libprotobuf-dev, libprotoc-dev, libqt5opengl5-dev, libqt5svg5-dev, libqt5websockets5-dev, libqt5x11extras5-dev, libzmq3-dev, libzstd-dev, protobuf-compiler, qtbase5-dev, ros-one-catkin, ros-one-roscpp, ros-one-roslib
Homepage: https://github.com/facontidavide/PlotJuggler
Standards-Version: 3.9.2

Package: ros-one-plotjuggler
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, binutils-dev, cppzmq-dev, libboost-all-dev, liblz4-dev, libprotobuf-dev, libprotoc-dev, libqt5opengl5-dev, libqt5svg5-dev, libqt5websockets5-dev, libqt5x11extras5-dev, libzmq3-dev, libzstd-dev, protobuf-compiler, qtbase5-dev, ros-one-roscpp, ros-one-roslib
Description: PlotJuggler: juggle with data

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/one/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_configure -- \
		-DFETCHCONTENT_FULLY_DISCONNECTED=OFF \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/one" \
		-DCMAKE_PREFIX_PATH="/opt/ros/one" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-one-plotjuggler//opt/ros/one/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_install
